#Author: Steven A. Kieffer
#16 Mar 2008

def verbatim(t):
  print t
  return t+'\n'

def verbPhrase(name,arity,subj,phrase,obj):
  s = name+':'+arity+'@\n'
  if obj: obj = ' '+obj
  s += '  reln:'+subj+' is '+'%e?'+phrase+'%ee?'+obj+'@\n'
  s += '  negn:'+subj+' is not '+phrase+obj+'@\n'
  s += '  plur:%'+subj+'% are '+phrase+obj+'@\n'
  s += '  nplu:%'+subj+'% are not '+phrase+obj+'@@\n'
  print s
  return s+'\n'

def relnVerb(name,arity,subj,verb,prep):
  s = name+':'+arity+'@\n'
  if prep: prep = ' '+prep
  s += '  reln:'+subj+' %e?'+verb+'s'+'%ee?'+prep+'@\n'
  s += '  negn:'+subj+' does not '+verb+prep+'@\n'
  s += '  plur:%'+subj+'% '+verb+prep+'@\n'
  s += '  nplu:%'+subj+'% do not '+verb+prep+'@@\n'
  print s
  return s+'\n'

def relnPrep(name,arity,symb,prep,phrase):
  s = name+':'+arity+'@\n'
  if phrase: phrase = ' '+phrase
  if symb:
      s += '  symb:#0 $'+symb+'$ #1@\n'
      s += '  nsym:#0 $\\not'+symb+'$ #1@\n'
  s += '  reln:#0 is %e?'+prep+'%ee? #1'+phrase+'@\n'
  s += '  negn:#0 is not '+prep+' #1'+phrase+'@\n'
  s += '  plur:%#0% are '+prep+' #1'+phrase+'@\n'
  s += '  nplu:%#0% are not '+prep+' #1'+phrase+'@\n'
  s += '  prep:#0 '+prep+' #1'+phrase+'@@\n'
  print s
  return s+'\n'

def infixRelnPrep(name,symb,prep):
  s = name+':infix@\n'
  if symb:
      s += '  symb:#0 $'+symb+'$ #1@\n'
      s += '  nsym:#0 $\\not'+symb+'$ #1@\n'
  s += '  reln:#0 is %e?'+prep+'%ee? #1@\n'
  s += '  negn:#0 is not '+prep+' #1@\n'
  s += '  plur:%#0% are '+prep+' #1@\n'
  s += '  nplu:%#0% are not '+prep+' #1@\n'
  s += '  prep:#0 '+prep+' #1@@\n'
  print s
  return s+'\n'

def infixRelnVerb(name,symb,verb):
  s = name+':infix@\n'
  if symb:
      s += '  symb:#0 $'+symb+'$ #1@\n'
      s += '  nsym:#0 $\\not'+symb+'$ #1@\n'
  s += '  reln:#0 %e?'+verb+'s'+'%ee? #1@\n'
  s += '  negn:#0 does not '+verb+' #1@\n'
  s += '  plur:%#0% '+verb+' #1@\n'
  s += '  nplu:%#0% do not '+verb+' #1@\n'
  s += '  prep:#0 '+verb+'ing'+' #1@@\n'
  print s
  return s+'\n'

def infixRelnHave(name,symb,phrase):
  s = name+':infix@\n'
  if symb:
      s += '  symb:#0 $'+symb+'$ #1@\n'
      s += '  nsym:#0 $\\not'+symb+'$ #1@\n'
  s += '  reln:#0 %e?'+'has '+phrase+'%ee? #1@\n'
  s += '  negn:#0 does not have '+phrase+' #1@\n'
  s += '  plur:%#0% have '+phrase+' #1@\n'
  s += '  nplu:%#0% do not have '+phrase+' #1@\n'
  s += '  prep:#0 having '+phrase+' #1@@\n'
  print s
  return s+'\n'

def adj(name,arity,subj,adj,prepPhrase):
  if prepPhrase: prepPhrase = " "+prepPhrase
  s = name+":"+arity+"@\n"
  s += "  reln:"+subj+" is %e?"+adj+"%ee?"+prepPhrase+"@\n"
  s += "  negn:"+subj+" is not "+adj+prepPhrase+"@\n"
  s += "  plur:%"+subj+"% are "+adj+prepPhrase+"@\n"
  s += "  nplu:%"+subj+"% are not "+adj+prepPhrase+"@@\n"
  print s
  return s+'\n'

def thingSimp(name,arity,theThing,objOut):
    thing(name,arity,'#0','',theThing,objOut)

def thing(name,arity,subj,objIn,theThing,objOut):
    isThingSpecial(name,arity,subj,objIn,0,theThing,0,objOut)

def specialPlural(name,arity,subj,objIn,theThing,plural,objOut):
    isThingSpecial(name,arity,subj,objIn,0,theThing,plural,objOut)

def specialIndef(name,arity,subj,objIn,indef,theThing,objOut):
    isThingSpecial(name,arity,subj,objIn,indef,theThing,0,objOut)

def isThingSpecial(name,arity,subj,objIn,indefOver,theThing,pluralOver,objOut):
    #Guess the indefinite article.
    if indefOver: indef = indefOver
    else:
        initial = theThing[0]
        if initial in ['a','e','i','o','u']: indef = 'an'
        else: indef = 'a'
    
    #Guess the pluralization.
    if pluralOver: plural = pluralOver
    else:
        last = theThing[len(theThing)-1]
        if last == 'y': plural = theThing[:-1]+'ies'
        elif last == 'f': plural = theThing[:-1]+'ves'
        elif last in ['j','s','x','z']: plural = theThing+'es'
        else: plural = theThing+'s'
    
    #Write the entry.
    if objIn: objIn += " "
    if objOut: objOut = " "+objOut
    obj = objIn+theThing+objOut
    objPlur = objIn+plural+objOut
    emphObj = objIn+"%e?"+theThing+"%ee?"+objOut
    
    s = name+":"+arity+"@\n"
    s += "  reln:"+subj+" is "+indef+" "+emphObj+"@\n"
    s += "  negn:"+subj+" is not "+indef+" "+obj+"@\n"
    s += "  plur:%"+subj+"% are "+objPlur+"@\n"
    s += "  nplu:%"+subj+"% are not "+objPlur+"@@\n"
    print s
    return s+'\n'

def func(name,arity,symb,word):
  s = name+':'+arity+'@\n'
  if symb:
      s += '  symb:'+symb+'@\n'
  s += '  word:'+word+'@@\n'
  print s
  return s+'\n'
  
def infixFunc(name,symb,phrase):
  s = name+':infix@\n'
  s += '  symb:#0 '+symb+' #1@\n'
  s += '  word:'+phrase+'@@\n'
  print s
  return s+'\n'






