 

public class NLBterm extends NLTerm {

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  NLTerm t;
  NLTerm[][] ttt;
  boolean isInWords = false;
  String translation = "";

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public NLBterm(NLTerm t, NLTerm[][] ttt) {
    this.t = t; this.ttt = ttt;
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------
  
  public String xlat(int mode) {
    //First call the xlat methods of the children, and figure out
    //if we are forced to return words.
    //Start with t.
    t.xlat(mode); this.isInWords |= t.isInWords();
    //Now the term arrays, if there are any.
    if (ttt!=null) {
      for (int i = 0; i < ttt.length; i++) {
        if (ttt[i]!=null) {
          for (int j = 0; j < ttt[i].length; j++) {
            ttt[i][j].xlat(mode); this.isInWords |= ttt[i][j].isInWords();
          }
        }
      }
    }
    //Finally, write the string.
    String x = "";
    if (this.isInWords || mode==NLPhrase.WORDS_MODE) {
      x = writeWords();
    } else {
      x = writeSymbols();
    }
    this.translation = x;
    return x;
  }
  
  public boolean isInWords() {
  //Should be called only *after* xlat.
    return this.isInWords;
  }

  public String getString() {
  //Should be called only *after* xlat.
    return this.translation;
  }
   
  String writeSymbols() {
    String s = "";
    s += t.getString();
    if (ttt!=null && ttt.length > 0) {
      for (int i = 0; i < ttt.length; i++) {
        s = (i==ttt.length-1?"":"[")+s+"(";
        for (int j = 0; j < ttt[i].length; j++) {
          s += (j==0?"":",")+ttt[i][j].getString();
        }
        s += ")"+(i==ttt.length-1?"":"]");
      }
    }
    return s;
  }
  
  String writeWords() {    
    String s = "";
    s += t.getString();
    if (ttt!=null && ttt.length > 0) {
      s += ", evaluated at ";
      for (int i = 0; i < ttt.length; i++) {
        s += (i==0?"":", the resulting function evaluated at ");
        for (int j = 0; j < ttt[i].length; j++) {
          s += (j==0?"":", ")+ttt[i][j].getString();
        }
      }
    }
    return s;
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 
