public class NLTerm extends NLPhrase {
  
  
  NLBterm t;
  NLInfixfunc[] aa;
  NLBterm[] tt;
  int parenDepth = 0;
  
  boolean isInWords = false;
  String translation = "";
  
  public NLTerm() {}
  
  public NLTerm(NLBterm t, NLInfixfunc[] aa, NLBterm[] tt) {
    this.t = t; this.aa = aa; this.tt = tt;
  }
  
  void parenthesize() {
    parenDepth++;
  }
  
  public String toString() {return "";}
  
  public String xlat(int mode) {
    if (aa == null || tt == null || aa.length == 0 || tt.length == 0
      ||aa.length != tt.length) {
      t.xlat(mode);
      this.isInWords |= t.isInWords();
      String x = t.getString();
      this.translation = x;
      return x;
    }
    
    String[] ts = new String[tt.length+1];
    boolean[] ws = new boolean[tt.length+1];
    t.xlat(mode); this.isInWords |= t.isInWords();
    ts[0] = t.getString(); ws[0] = t.isInWords();
    for (int i = 0; i < tt.length; i++) {
      tt[i].xlat(mode); this.isInWords |= tt[i].isInWords();
      ts[i+1] = tt[i].getString(); ws[i+1] = tt[i].isInWords();
    }
    
    String[] P = retrievePrecedenceNumbers(aa);
    int[] Q = makePrecOrder(P);
    int n = Q.length;
    String s; int i,infixMode;
    for (int k = 0; k < n; k++) {
      i = Q[k];
      aa[i].setArgStrings(ts[i],ts[i+1]);
      infixMode = mode;
      if (ws[i] || ws[i+1]) {
        infixMode |= NLInfixrel.WORDS;
        infixMode &= (~NLInfixrel.DEFAULT);
      }
      aa[i].xlat(infixMode); this.isInWords |= aa[i].isInWords();
      s = aa[i].getString();
      ts[i] = s; ws[i] = aa[i].isInWords();
      for (int j = i+1; j < n; j++) {
        aa[j-1] = aa[j];
        ts[j] = ts[j+1];
      }
      for (int j = k+1; j < n; j++) {
        if (Q[j] > i) {Q[j] = Q[j]-1;}
      }
    }
    String x = ts[0];
    this.translation = x;
    return x;
/*    
    //First translate all the children, and update the isInWords
    //boolean accordingly.
    //Start with t.
    t.xlat(mode); this.isInWords |= t.isInWords();
    //Now the infixfuncs and other terms, if there are any.
    if (aa!=null && tt != null) {
    //We assume that aa and tt are the same length.
      boolean lastWords = t.isInWords();
      boolean nextWords;
      int infixMode;
      for (int i = 0; i < aa.length; i++) {
        tt[i].xlat(mode); this.isInWords |= tt[i].isInWords();
        nextWords = tt[i].isInWords();
        infixMode = mode;
        if (lastWords || nextWords) {
          infixMode |= NLInfixrel.WORDS;
          infixMode &= (~NLInfixrel.DEFAULT);
        }
        aa[i].xlat(infixMode); this.isInWords |= aa[i].isInWords();
        lastWords = nextWords;
      }
    }
    //Write the translation.
    String x = writePhrase();
    this.translation = x;
    return x;
*/
  }
  
  public boolean isInWords() {
  //Should be called only *after* xlat.
    return this.isInWords;
  }

  public String getString() {
  //Should be called only *after* xlat.
    return this.translation;
  }
/*  
  String writePhrase() {
    String s = "";
    s += t.getString();
    if (aa!=null) {
      for (int i = 0; i < aa.length; i++) {
        s += " "+aa[i].getString()+" "+tt[i].getString();
      }
    }
    //Parenthesize, if we are writing symbols.
    if (!this.isInWords()) {
      String open = "", close = "";
      for (int i = 0; i < parenDepth; i++) {
        open += "("; close += ")";
      }
      s = open+s+close;
    }
    return s;
  }
*/  
  int[] makePrecOrder(String[] P) {
    int[] Q = new int[P.length];
    String value;
    int j;
    
    for (int i = 1; i < P.length; i++) {
      value = P[i];
      j = i-1;
      while (j>=0 && later(P[j],value)) {
        P[j+1] = P[j];
        Q[j+1] = Q[j]; //OK since j < i.
        j--;
      }
      P[j+1] = value;
      Q[j+1] = i;
    }
    
    return Q;
  }
  
  String[] retrievePrecedenceNumbers(NLInfixfunc[] aa) {
    String[] S = new String[aa.length];
    for (int i = 0; i < aa.length; i++) {
      S[i] = aa[i].getPrecedence();
    }
    return S;
  }
  
  boolean later(String A, String B) {
  //Compares precedence numbers, and says whether A is the precedence
  //number of an operation that comes later than an operation with
  //precedence number B.
  //We assume that the function with A comes to the left of the function
  //with B. So if the precedence numbers are the same, then we return false.
  
    if (A.equals("infinity")) {
      if (B.equals("infinity")) {
        return false;
      } else {
        return true;
      }
    } else if (B.equals("infinity")) {
      return false;
    }
    
    char Asign = A.charAt(0);
    char Bsign = B.charAt(0);
    
    if (Bsign == '-') {
      if (Asign != '-') {
        return true;
      } else {
        A = A.substring(1,A.length());
        B = B.substring(1,B.length());
        return (A.compareTo(B) < 0);
      }
    } else {
      if (Asign == '-') {
        return false;
      } else {
        return (A.compareTo(B) > 0);
      }
    }
    
  }

}
